require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe KineController do

  # This should return the minimal set of attributes required to create a valid
  # Cow. As you add validations to Cow, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all kine as @kine" do
      cow = Cow.create! valid_attributes
      get :index
      assigns(:kine).should eq([cow])
    end
  end

  describe "GET show" do
    it "assigns the requested cow as @cow" do
      cow = Cow.create! valid_attributes
      get :show, :id => cow.id.to_s
      assigns(:cow).should eq(cow)
    end
  end

  describe "GET new" do
    it "assigns a new cow as @cow" do
      get :new
      assigns(:cow).should be_a_new(Cow)
    end
  end

  describe "GET edit" do
    it "assigns the requested cow as @cow" do
      cow = Cow.create! valid_attributes
      get :edit, :id => cow.id.to_s
      assigns(:cow).should eq(cow)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Cow" do
        expect {
          post :create, :cow => valid_attributes
        }.to change(Cow, :count).by(1)
      end

      it "assigns a newly created cow as @cow" do
        post :create, :cow => valid_attributes
        assigns(:cow).should be_a(Cow)
        assigns(:cow).should be_persisted
      end

      it "redirects to the created cow" do
        post :create, :cow => valid_attributes
        response.should redirect_to(Cow.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved cow as @cow" do
        # Trigger the behavior that occurs when invalid params are submitted
        Cow.any_instance.stub(:save).and_return(false)
        post :create, :cow => {}
        assigns(:cow).should be_a_new(Cow)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Cow.any_instance.stub(:save).and_return(false)
        post :create, :cow => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested cow" do
        cow = Cow.create! valid_attributes
        # Assuming there are no other kine in the database, this
        # specifies that the Cow created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Cow.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => cow.id, :cow => {'these' => 'params'}
      end

      it "assigns the requested cow as @cow" do
        cow = Cow.create! valid_attributes
        put :update, :id => cow.id, :cow => valid_attributes
        assigns(:cow).should eq(cow)
      end

      it "redirects to the cow" do
        cow = Cow.create! valid_attributes
        put :update, :id => cow.id, :cow => valid_attributes
        response.should redirect_to(cow)
      end
    end

    describe "with invalid params" do
      it "assigns the cow as @cow" do
        cow = Cow.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Cow.any_instance.stub(:save).and_return(false)
        put :update, :id => cow.id.to_s, :cow => {}
        assigns(:cow).should eq(cow)
      end

      it "re-renders the 'edit' template" do
        cow = Cow.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Cow.any_instance.stub(:save).and_return(false)
        put :update, :id => cow.id.to_s, :cow => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested cow" do
      cow = Cow.create! valid_attributes
      expect {
        delete :destroy, :id => cow.id.to_s
      }.to change(Cow, :count).by(-1)
    end

    it "redirects to the kine list" do
      cow = Cow.create! valid_attributes
      delete :destroy, :id => cow.id.to_s
      response.should redirect_to(kine_url)
    end
  end

end
